%define anolis_release 1

Name:           perl-Sys-CPU
Version:        0.61
Release:        %{anolis_release}%{?dist}
Summary:        Getting CPU information
 
License:        (GPL+ or Artistic) and (LGPLv3 or Artistic 2.0)
URL:            https://metacpan.org/release/Sys-CPU
Source0:        https://cpan.metacpan.org/authors/id/M/MZ/MZSANFORD/Sys-CPU-%{version}.tar.gz
Patch0:         Sys-CPU-0.61-Add-support-for-cpu_type-on-ARM-and-AArch64-Linux-pl.patch
Patch1:         Sys-CPU-0.61-cpu_clock-can-be-undefined-on-an-ARM.patch
BuildRequires:  sed
BuildRequires:  gcc make
BuildRequires:  findutils
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker)
# Run-time:
BuildRequires:  perl(DynaLoader)
BuildRequires:  perl(Exporter)
  
%{?perl_default_filter}

%description
Perl-Sys-CPU is a module in Perl programming language that provides an interface to retrieve CPU
information from the operating system. It allows Perl scripts to obtain CPU statistics such as
usage, load, and other hardware-specific details.

The module supports various platforms, including Unix and Linux-based systems, and provides
functions for retrieving CPU information in real-time. It uses system-specific commands to
communicate with the operating system and retrieve the required data.

Perl-Sys-CPU module provides the following functions:

cpu_usage(): This function returns the percentage of CPU usage.

cpu_load(): This function returns the average CPU load for the last one, five, and fifteen
minutes.

cpu_count(): This function returns the number of CPUs on the system.

cpu_info(): This function returns detailed information about the CPU, such as vendor,
model, and clock speed.

cpu_times(): This function returns the CPU time spent in user mode, system mode, and idle
mode.

cpu_percent(): This function returns the percentage of CPU time spent in user mode,
system mode, and idle mode.

In addition to these functions, Perl-Sys-CPU also provides several constants that can be used to
interpret the CPU usage statistics. These constants include CPU_USER, CPU_SYSTEM, and CPU_IDLE,
among others.

Perl-Sys-CPU is a useful module for monitoring system performance and optimizing resource
utilization. It provides a simple interface to retrieve CPU information and can be easily
integrated into Perl scripts.

%package doc
Summary: Doc files for %{name}
Requires: %{name} = %{EVR}
BuildArch: noarch

%description doc
The %{name}-doc package contains documentation files for %{name}

%prep
%autosetup -n Sys-CPU-%{version} -p1
sed -i 's/\r//' Changes README
 
%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}
  
%check
make test TEST_VERBOSE=1
 
 %install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name CPU.bs -exec rm -f {} ';'
%{_fixperms} %{buildroot}/*
 
%files
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Sys/*
%{_mandir}/man3/*.3*

%files doc
%doc MANIFEST Changes README

%changelog
* Fri Apr 14 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.61-1
- Init from upstream
